django_project/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path("", include("myg.urls")),
    path("admin/", admin.site.urls),
    path("accounts/", include("users.urls")),
    path("accounts/", include("django.contrib.auth.urls")),
]

myg/urls.py
"""myg app URL."""
from django.urls import path

from myg import views

app_name = "myg"

urlpatterns = [
    path("", views.CourseList.as_view(), name="course-list"),
    path("course/add/", views.CourseCreate.as_view(), name="course-create"),
    path("course/<int:pk>/", views.CourseDetail.as_view(), name="course-detail"),
    path("course/<int:pk>/update", views.CourseUpdate.as_view(), name="course-update"),
    path(
        "course/<int:course_id>/assessment/",
        views.AssessmentList.as_view(),
        name="assessment-list",
    ),
    path(
        "course/<int:course_id>/assessment/add/",
        views.AssesmentCreate.as_view(),
        name="assessment-create",
    ),
    path(
        "course/<int:course_id>/assessment/<int:pk>/",
        views.AssessmentDetail.as_view(),
        name="assessment-detail",
    ),
    path(
        "course/<int:course_id>/assessment/<int:pk>/update/",
        views.AssessmentUpdate.as_view(),
        name="assessment-update",
    ),
    path(
        "course/<int:pk>/enrollment/",
        views.EntrollmentList.as_view(),
        name="enrollment-list",
    ),
    path(
        "course/<int:pk>/enrollment/add/",
        views.EnrollmentCreate.as_view(),
        name="enrollment-create",
    ),
    path(
        "course/<int:course_id>/assessment/<int:assessment_id>/grades/",
        views.AssessmentGradeList.as_view(),
        name="assessment-grade-list",
    ),
    path(
        "course/<int:course_id>/assessment/<int:assessment_id>/grades/add/",
        views.AssessmentGradeCreate.as_view(),
        name="assessment-grade-create",
    ),
    path(
        "course/<int:course_id>/assessment/<int:assessment_id>/grades/<int:pk>/",
        views.GradeDetail.as_view(),
        name="grade-detail",
    ),
    path(
        "course/<int:course_id>/assessment/<int:assessment_id>/grades/<int:pk>/update/",
        views.AssessmentGradeUpdate.as_view(),
        name="assessment-grade-update",
    ),
]

users/urls.py
"""Accounts app URL Configuration."""
from django.urls import path
from django.views.generic import TemplateView

from users import views

app_name = "users"
urlpatterns = [
    path("", TemplateView.as_view(template_name="registration/signup.html"), name="signup"),
    path("signup/student/", views.StudentSignUpView.as_view(), name="student_signup"),
    path("signup/teacher/", views.TeacherSignUpView.as_view(), name="teacher_signup"),
    path("signup/parent/", views.ParentSignUpView.as_view(), name="parent_signup"),
]

users/models.py
"""Accounts models."""
from django.contrib.auth.models import AbstractUser
from django.db import models
from django.utils.translation import gettext_lazy as _

from users.managers import CustomUserManager


class CustomUser(AbstractUser):
    """Custom User class."""

    username = None
    email = models.EmailField(_("email address"), unique=True)

    USERNAME_FIELD = "email"
    REQUIRED_FIELDS = []

    is_student = models.BooleanField(default=False)
    is_teacher = models.BooleanField(default=False)
    is_parent = models.BooleanField(default=False)

    objects = CustomUserManager()

    def __str__(self):
        """Return email as the object's string representation."""
        return self.email

users/forms.py
"""Forms for accounts app."""
from django.contrib.auth.forms import UserChangeForm, UserCreationForm

from users.models import CustomUser


class CustomUserCreationForm(UserCreationForm):
    """Registration form."""

    class Meta:
        """Meta class."""

        model = CustomUser
        fields = ("first_name", "last_name", "email", "password1", "password2")


class CustomUserChangeForm(UserChangeForm):
    """User profile change view."""

    class Meta:
        """Meta class."""

        model = CustomUser
        fields = ("email",)

users/views.py
"""Accounts view."""
from django.urls import reverse_lazy
from django.views import generic

from users.forms import CustomUserCreationForm
from users.models import CustomUser


class StudentSignUpView(generic.CreateView):
    """Sign up view for Student Users."""

    model = CustomUser
    form_class = CustomUserCreationForm
    template_name = "generic_create_update_form.html"
    success_url = reverse_lazy("login")
    extra_context = {"title_text": "Student Sign Up", "button_text": "Register"}

    def form_valid(self, form: object) -> object:
        """For valid form submission."""
        form.instance.is_student = True
        return super().form_valid(form)


class TeacherSignUpView(generic.CreateView):
    """Sign up view for Teacher Users."""

    model = CustomUser
    form_class = CustomUserCreationForm
    template_name = "generic_create_update_form.html"
    success_url = reverse_lazy("login")
    extra_context = {"title_text": "Teacher Sign Up", "button_text": "Register"}

    def form_valid(self, form: object) -> object:
        """For valid form submission."""
        form.instance.is_teacher = True
        return super().form_valid(form)


class ParentSignUpView(generic.CreateView):
    """Sign up view for Parent Users."""

    model = CustomUser
    form_class = CustomUserCreationForm
    template_name = "generic_create_update_form.html"
    success_url = reverse_lazy("login")
    extra_context = {"title_text": "Parent Sign Up", "button_text": "Register"}

    def form_valid(self, form: object) -> object:
        """For valid form submission."""
        form.instance.is_parent = True
        return super().form_valid(form)

users/templates/base_generic.html
{# Load the tag library #}
{% load django_bootstrap5 %}
{% load static %}
<!DOCTYPE html>
<html lang="us-en">
    <head>
        <meta charset="UTF-8" />
        <meta name="description" content="Polls App" />
        <meta name="keywords" content="HTML, CSS, JavaScript" />
        <meta name="author" content="John Doe" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <link rel="shortcut icon"
              type="image/png"
              href="{% static 'img/favicon.ico' %}"/>
        <title>Polls App</title>
        {# Load CSS and JavaScript #}
        {% bootstrap_css %}
        {% bootstrap_javascript %}
        {# Display django.contrib.messages as Bootstrap alerts #}
        {% bootstrap_messages %}
        <link rel="stylesheet" href="{% static 'css/base.css' %}" />
        <link href="{% static 'fontawesomefree/css/all.min.css' %}"
              rel="stylesheet"
              type="text/css"/>
        {% block style %}
        {% endblock style %}
    </head>
    <body>
        {% include "navbar.html" %}
        <div class="container">
            <h1 class="text-center fw-bold mb-5">
                {% block title %}
                {% endblock title %}
            </h1>
            {% block content %}
            {% endblock content %}
        </div>
        {% include "footer.html" %}
    </body>
</html>

users/templates/footer.html
<footer class="footer pt-3 mt-4 text-muted">
    <div class="container">
        Django Project template is powered by
        <a target="_blank" href="https://getbootstrap.com/">Bootstrap</a>
        and
        <a target="_blank" href="https://fontawesome.com/">Font awesome</a>.
    </div>
</footer>

users/templates/generic_create_update_form.html
{% extends "base_generic.html" %}
{% load django_bootstrap5 %}
{% block title %}
    {{ title_text }}
{% endblock title %}
{% block content %}
    <div class="d-flex justify-content-center">
        <div class="col-md-4">
            <form method="post">
                {% csrf_token %}
                {% bootstrap_form form %}
                {{ form.media }}
                <div class="text-center">
                    <button type="submit" class="btn btn-primary">{{ button_text }}</button>
                </div>
            </form>
        </div>
    </div>
{% endblock content %}

users/templates/navbar.html
<nav class="navbar navbar-expand-md navbar-dark fixed-top bg-dark justify-content-between">
    <div class="container">
        <a class="navbar-brand" href="{% url 'myg:course-list' %}">
            <i class="fa-solid fa-square-poll-vertical"></i> MyG
        </a>
        <button class="navbar-toggler"
                type="button"
                data-toggle="collapse"
                data-target="#navbarsExampleDefault"
                aria-controls="navbarsExampleDefault"
                aria-expanded="false"
                aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="navbar-collapse collapse" id="#navbarsExampleDefault">
            <ul class="navbar-nav ms-auto mb-2 mb-lg-0">
                {% if user.is_authenticated %}
                    <div class="dropdown">
                        <a class="nav-link dropdown-toggle"
                           role="button"
                           data-toggle="dropdown"
                           data-bs-toggle="dropdown"
                           aria-expanded="false">
                            <i class="fa-solid fa-user-shield"></i> {{ user.email }}
                        </a>
                        <ul class="dropdown-menu">
                            <li>
                                <a class="dropdown-item" href="{% url 'password_change' %}">
                                    <i class="fa-solid fa-user-cog"></i> Change password
                                </a>
                            </li>
                            <li>
                                <div class="dropdown-divider"></div>
                            </li>
                            <li>
                                <a class="dropdown-item" href="{% url 'logout' %}">
                                    <i class="fa-solid fa-sign-out-alt"></i> Log out
                                </a>
                            </li>
                        </ul>
                    </div>
                {% else %}
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'login' %}">
                            <i class="fa-solid fa-sign-in"></i> Sign in
                        </a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'users:signup' %}">
                            <i class="fa-solid fa-user-edit"></i> Sign up
                        </a>
                    </li>
                {% endif %}
            </ul>
        </div>
    </div>
</nav>